/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
 */
#ifndef __WebKitDOMSelection_H__
#define __WebKitDOMSelection_H__

#include "webkit/webkitdomdefines.h"
#include <glib-object.h>
#include <webkit/webkitdefines.h>
#include "webkit/WebKitDOMObject.h"


G_BEGIN_DECLS


#define WEBKIT_TYPE_DOM_SELECTION            (webkit_dom_selection_get_type())
#define WEBKIT_DOM_SELECTION(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), WEBKIT_TYPE_DOM_SELECTION, WebKitDOMSelection))
#define WEBKIT_DOM_SELECTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  WEBKIT_TYPE_DOM_SELECTION, WebKitDOMSelection)Class)
#define WEBKIT_IS_DOM_SELECTION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), WEBKIT_TYPE_DOM_SELECTION))
#define WEBKIT_IS_DOM_SELECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  WEBKIT_TYPE_DOM_SELECTION))
#define WEBKIT_DOM_SELECTION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  WEBKIT_TYPE_DOM_SELECTION, WebKitDOMSelectionClass))

struct _WebKitDOMSelection {
    WebKitDOMObject parent_instance;
};

struct _WebKitDOMSelectionClass {
    WebKitDOMObjectClass parent_class;
};

WEBKIT_API GType
webkit_dom_selection_get_type (void);

WEBKIT_API void
webkit_dom_selection_collapse (WebKitDOMSelection *selection, WebKitNode * node, glong index, GError **error);

WEBKIT_API void
webkit_dom_selection_collapse_to_end (WebKitDOMSelection *selection);

WEBKIT_API void
webkit_dom_selection_collapse_to_start (WebKitDOMSelection *selection);

WEBKIT_API void
webkit_dom_selection_delete_from_document (WebKitDOMSelection *selection);

WEBKIT_API gboolean
webkit_dom_selection_contains_node (WebKitDOMSelection *selection, WebKitNode * node, gboolean allow_partial);

WEBKIT_API void
webkit_dom_selection_select_all_children (WebKitDOMSelection *selection, WebKitNode * node, GError **error);

WEBKIT_API void
webkit_dom_selection_extend (WebKitDOMSelection *selection, WebKitNode * node, glong offset, GError **error);

WEBKIT_API WebKitRange *
webkit_dom_selection_get_range_at (WebKitDOMSelection *selection, glong index, GError **error);

WEBKIT_API void
webkit_dom_selection_remove_all_ranges (WebKitDOMSelection *selection);

WEBKIT_API void
webkit_dom_selection_add_range (WebKitDOMSelection *selection, WebKitRange * range);

WEBKIT_API void
webkit_dom_selection_modify (WebKitDOMSelection *selection, gchar * alter, gchar * direction, gchar * granularity);

WEBKIT_API void
webkit_dom_selection_set_base_and_extent (WebKitDOMSelection *selection, WebKitNode * base_node, glong base_offset, WebKitNode * extent_node, glong extent_offset, GError **error);

WEBKIT_API void
webkit_dom_selection_set_position (WebKitDOMSelection *selection, WebKitNode * node, glong offset, GError **error);

WEBKIT_API void
webkit_dom_selection_empty (WebKitDOMSelection *selection);

WEBKIT_API WebKitNode *
webkit_dom_selection_get_anchor_node (WebKitDOMSelection *selection);

WEBKIT_API glong
webkit_dom_selection_get_anchor_offset (WebKitDOMSelection *selection);

WEBKIT_API WebKitNode *
webkit_dom_selection_get_focus_node (WebKitDOMSelection *selection);

WEBKIT_API glong
webkit_dom_selection_get_focus_offset (WebKitDOMSelection *selection);

WEBKIT_API gboolean
webkit_dom_selection_get_is_collapsed (WebKitDOMSelection *selection);

WEBKIT_API glong
webkit_dom_selection_get_range_count (WebKitDOMSelection *selection);

WEBKIT_API WebKitNode *
webkit_dom_selection_get_base_node (WebKitDOMSelection *selection);

WEBKIT_API glong
webkit_dom_selection_get_base_offset (WebKitDOMSelection *selection);

WEBKIT_API WebKitNode *
webkit_dom_selection_get_extent_node (WebKitDOMSelection *selection);

WEBKIT_API glong
webkit_dom_selection_get_extent_offset (WebKitDOMSelection *selection);

G_END_DECLS

#endif /* __WebKitDOMSelection_H__ */
