/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
 */
#ifndef __WebKitDOMWindow_H__
#define __WebKitDOMWindow_H__

#include "webkit/webkitdomdefines.h"
#include <glib-object.h>
#include <webkit/webkitdefines.h>
#include "webkit/WebKitDOMObject.h"


G_BEGIN_DECLS


#define WEBKIT_TYPE_DOM_WINDOW            (webkit_dom_window_get_type())
#define WEBKIT_DOM_WINDOW(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), WEBKIT_TYPE_DOM_WINDOW, WebKitDOMWindow))
#define WEBKIT_DOM_WINDOW_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  WEBKIT_TYPE_DOM_WINDOW, WebKitDOMWindow)Class)
#define WEBKIT_IS_DOM_WINDOW(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), WEBKIT_TYPE_DOM_WINDOW))
#define WEBKIT_IS_DOM_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  WEBKIT_TYPE_DOM_WINDOW))
#define WEBKIT_DOM_WINDOW_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  WEBKIT_TYPE_DOM_WINDOW, WebKitDOMWindowClass))

struct _WebKitDOMWindow {
    WebKitDOMObject parent_instance;
};

struct _WebKitDOMWindowClass {
    WebKitDOMObjectClass parent_class;
};

WEBKIT_API GType
webkit_dom_window_get_type (void);

WEBKIT_API WebKitDOMSelection *
webkit_dom_window_get_selection (WebKitDOMWindow *window);

WEBKIT_API void
webkit_dom_window_focus (WebKitDOMWindow *window);

WEBKIT_API void
webkit_dom_window_blur (WebKitDOMWindow *window);

WEBKIT_API void
webkit_dom_window_close (WebKitDOMWindow *window);

WEBKIT_API void
webkit_dom_window_print (WebKitDOMWindow *window);

WEBKIT_API void
webkit_dom_window_stop (WebKitDOMWindow *window);

WEBKIT_API void
webkit_dom_window_alert (WebKitDOMWindow *window, gchar * message);

WEBKIT_API gboolean
webkit_dom_window_confirm (WebKitDOMWindow *window, gchar * message);

WEBKIT_API gchar *
webkit_dom_window_prompt (WebKitDOMWindow *window, gchar * message, gchar * default_value);

WEBKIT_API gboolean
webkit_dom_window_find (WebKitDOMWindow *window, gchar * string, gboolean case_sensitive, gboolean backwards, gboolean wrap, gboolean whole_word, gboolean search_in_frames, gboolean show_dialog);

WEBKIT_API void
webkit_dom_window_scroll_by (WebKitDOMWindow *window, glong x, glong y);

WEBKIT_API void
webkit_dom_window_scroll_to (WebKitDOMWindow *window, glong x, glong y);

WEBKIT_API void
webkit_dom_window_scroll (WebKitDOMWindow *window, glong x, glong y);

WEBKIT_API void
webkit_dom_window_move_by (WebKitDOMWindow *window, gfloat x, gfloat y);

WEBKIT_API void
webkit_dom_window_move_to (WebKitDOMWindow *window, gfloat x, gfloat y);

WEBKIT_API void
webkit_dom_window_resize_by (WebKitDOMWindow *window, gfloat x, gfloat y);

WEBKIT_API void
webkit_dom_window_resize_to (WebKitDOMWindow *window, gfloat width, gfloat height);

WEBKIT_API WebKitCSSStyleDeclaration *
webkit_dom_window_get_computed_style (WebKitDOMWindow *window, WebKitElement * element, gchar * pseudo_element);

WEBKIT_API WebKitCSSRuleList *
webkit_dom_window_get_matched_css_rules (WebKitDOMWindow *window, WebKitElement * element, gchar * pseudo_element, gboolean author_only);

WEBKIT_API WebKitDatabase *
webkit_dom_window_open_database (WebKitDOMWindow *window, gchar * name, gchar * version, gchar * display_name, gulong estimated_size, GError **error);


/* TODO: custom function webkit_dom_window_post_message */


/* TODO: custom function webkit_dom_window_set_timeout */


/* TODO: custom function webkit_dom_window_clear_timeout */


/* TODO: custom function webkit_dom_window_set_interval */


/* TODO: custom function webkit_dom_window_clear_interval */


/* TODO: custom function webkit_dom_window_atob */


/* TODO: custom function webkit_dom_window_btoa */


/* TODO: custom function webkit_dom_window_add_event_listener */


/* TODO: custom function webkit_dom_window_remove_event_listener */

WEBKIT_API WebKitScreen *
webkit_dom_window_get_screen (WebKitDOMWindow *window);

WEBKIT_API WebKitHistory *
webkit_dom_window_get_history (WebKitDOMWindow *window);

WEBKIT_API WebKitBarInfo *
webkit_dom_window_get_locationbar (WebKitDOMWindow *window);

WEBKIT_API WebKitBarInfo *
webkit_dom_window_get_menubar (WebKitDOMWindow *window);

WEBKIT_API WebKitBarInfo *
webkit_dom_window_get_personalbar (WebKitDOMWindow *window);

WEBKIT_API WebKitBarInfo *
webkit_dom_window_get_scrollbars (WebKitDOMWindow *window);

WEBKIT_API WebKitBarInfo *
webkit_dom_window_get_statusbar (WebKitDOMWindow *window);

WEBKIT_API WebKitBarInfo *
webkit_dom_window_get_toolbar (WebKitDOMWindow *window);

WEBKIT_API WebKitNavigator *
webkit_dom_window_get_navigator (WebKitDOMWindow *window);

WEBKIT_API WebKitNavigator *
webkit_dom_window_get_client_information (WebKitDOMWindow *window);

WEBKIT_API WebKitElement *
webkit_dom_window_get_frame_element (WebKitDOMWindow *window);

WEBKIT_API gboolean
webkit_dom_window_get_offscreen_buffering (WebKitDOMWindow *window);

WEBKIT_API glong
webkit_dom_window_get_outer_height (WebKitDOMWindow *window);

WEBKIT_API glong
webkit_dom_window_get_outer_width (WebKitDOMWindow *window);

WEBKIT_API glong
webkit_dom_window_get_inner_height (WebKitDOMWindow *window);

WEBKIT_API glong
webkit_dom_window_get_inner_width (WebKitDOMWindow *window);

WEBKIT_API glong
webkit_dom_window_get_screen_x (WebKitDOMWindow *window);

WEBKIT_API glong
webkit_dom_window_get_screen_y (WebKitDOMWindow *window);

WEBKIT_API glong
webkit_dom_window_get_screen_left (WebKitDOMWindow *window);

WEBKIT_API glong
webkit_dom_window_get_screen_top (WebKitDOMWindow *window);

WEBKIT_API glong
webkit_dom_window_get_scroll_x (WebKitDOMWindow *window);

WEBKIT_API glong
webkit_dom_window_get_scroll_y (WebKitDOMWindow *window);

WEBKIT_API glong
webkit_dom_window_get_page_x_offset (WebKitDOMWindow *window);

WEBKIT_API glong
webkit_dom_window_get_page_y_offset (WebKitDOMWindow *window);

WEBKIT_API gboolean
webkit_dom_window_get_closed (WebKitDOMWindow *window);

WEBKIT_API gulong
webkit_dom_window_get_length (WebKitDOMWindow *window);

WEBKIT_API gchar *
webkit_dom_window_get_name (WebKitDOMWindow *window);

WEBKIT_API void
webkit_dom_window_set_name (WebKitDOMWindow *window, gchar * value);

WEBKIT_API gchar *
webkit_dom_window_get_status (WebKitDOMWindow *window);

WEBKIT_API void
webkit_dom_window_set_status (WebKitDOMWindow *window, gchar * value);

WEBKIT_API gchar *
webkit_dom_window_get_default_status (WebKitDOMWindow *window);

WEBKIT_API void
webkit_dom_window_set_default_status (WebKitDOMWindow *window, gchar * value);

WEBKIT_API WebKitDOMWindow *
webkit_dom_window_get_self (WebKitDOMWindow *window);

WEBKIT_API WebKitDOMWindow *
webkit_dom_window_get_window (WebKitDOMWindow *window);

WEBKIT_API WebKitDOMWindow *
webkit_dom_window_get_frames (WebKitDOMWindow *window);

WEBKIT_API WebKitDOMWindow *
webkit_dom_window_get_opener (WebKitDOMWindow *window);

WEBKIT_API WebKitDOMWindow *
webkit_dom_window_get_parent (WebKitDOMWindow *window);

WEBKIT_API WebKitDOMWindow *
webkit_dom_window_get_top (WebKitDOMWindow *window);

WEBKIT_API WebKitDocument *
webkit_dom_window_get_document (WebKitDOMWindow *window);

WEBKIT_API gdouble
webkit_dom_window_get_device_pixel_ratio (WebKitDOMWindow *window);

WEBKIT_API WebKitDOMApplicationCache *
webkit_dom_window_get_application_cache (WebKitDOMWindow *window);

WEBKIT_API WebKitStorage *
webkit_dom_window_get_session_storage (WebKitDOMWindow *window);

WEBKIT_API WebKitStorage *
webkit_dom_window_get_local_storage (WebKitDOMWindow *window);

WEBKIT_API WebKitConsole *
webkit_dom_window_get_console (WebKitDOMWindow *window);

G_END_DECLS

#endif /* __WebKitDOMWindow_H__ */
