/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
 */
#ifndef __WebKitDocument_H__
#define __WebKitDocument_H__

#include "webkit/webkitdomdefines.h"
#include <glib-object.h>
#include <webkit/webkitdefines.h>
#include "webkit/WebKitNode.h"


G_BEGIN_DECLS


#define WEBKIT_TYPE_DOCUMENT            (webkit_document_get_type())
#define WEBKIT_DOCUMENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), WEBKIT_TYPE_DOCUMENT, WebKitDocument))
#define WEBKIT_DOCUMENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  WEBKIT_TYPE_DOCUMENT, WebKitDocument)Class)
#define WEBKIT_IS_DOCUMENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), WEBKIT_TYPE_DOCUMENT))
#define WEBKIT_IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  WEBKIT_TYPE_DOCUMENT))
#define WEBKIT_DOCUMENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  WEBKIT_TYPE_DOCUMENT, WebKitDocumentClass))

struct _WebKitDocument {
    WebKitNode parent_instance;
};

struct _WebKitDocumentClass {
    WebKitNodeClass parent_class;
};

WEBKIT_API GType
webkit_document_get_type (void);

WEBKIT_API WebKitElement *
webkit_document_create_element (WebKitDocument *document, gchar * tag_name, GError **error);

WEBKIT_API WebKitDocumentFragment *
webkit_document_create_document_fragment (WebKitDocument *document);

WEBKIT_API WebKitText *
webkit_document_create_text_node (WebKitDocument *document, gchar * data);

WEBKIT_API WebKitComment *
webkit_document_create_comment (WebKitDocument *document, gchar * data);

WEBKIT_API WebKitCDATASection *
webkit_document_create_cdata_section (WebKitDocument *document, gchar * data, GError **error);

WEBKIT_API WebKitProcessingInstruction *
webkit_document_create_processing_instruction (WebKitDocument *document, gchar * target, gchar * data, GError **error);

WEBKIT_API WebKitAttr *
webkit_document_create_attribute (WebKitDocument *document, gchar * name, GError **error);

WEBKIT_API WebKitEntityReference *
webkit_document_create_entity_reference (WebKitDocument *document, gchar * name, GError **error);

WEBKIT_API WebKitNodeList *
webkit_document_get_elements_by_tag_name (WebKitDocument *document, gchar * tagname);

WEBKIT_API WebKitNode *
webkit_document_import_node (WebKitDocument *document, WebKitNode * imported_node, gboolean deep, GError **error);

WEBKIT_API WebKitElement *
webkit_document_create_element_ns (WebKitDocument *document, gchar * namespace_uri, gchar * qualified_name, GError **error);

WEBKIT_API WebKitAttr *
webkit_document_create_attribute_ns (WebKitDocument *document, gchar * namespace_uri, gchar * qualified_name, GError **error);

WEBKIT_API WebKitNodeList *
webkit_document_get_elements_by_tag_name_ns (WebKitDocument *document, gchar * namespace_uri, gchar * local_name);

WEBKIT_API WebKitElement *
webkit_document_get_element_by_id (WebKitDocument *document, gchar * element_id);

WEBKIT_API WebKitNode *
webkit_document_adopt_node (WebKitDocument *document, WebKitNode * source, GError **error);


/* TODO: event function webkit_document_create_event */

WEBKIT_API WebKitRange *
webkit_document_create_range (WebKitDocument *document);

WEBKIT_API WebKitNodeIterator *
webkit_document_create_node_iterator (WebKitDocument *document, WebKitNode * root, gulong what_to_show, WebKitNodeFilter * filter, gboolean expand_entity_references, GError **error);

WEBKIT_API WebKitTreeWalker *
webkit_document_create_tree_walker (WebKitDocument *document, WebKitNode * root, gulong what_to_show, WebKitNodeFilter * filter, gboolean expand_entity_references, GError **error);

WEBKIT_API WebKitCSSStyleDeclaration *
webkit_document_get_override_style (WebKitDocument *document, WebKitElement * element, gchar * pseudo_element);

WEBKIT_API WebKitXPathExpression *
webkit_document_create_expression (WebKitDocument *document, gchar * expression, WebKitXPathNSResolver * resolver, GError **error);

WEBKIT_API WebKitXPathNSResolver *
webkit_document_create_ns_resolver (WebKitDocument *document, WebKitNode * node_resolver);

WEBKIT_API WebKitXPathResult *
webkit_document_evaluate (WebKitDocument *document, gchar * expression, WebKitNode * context_node, WebKitXPathNSResolver * resolver, gushort type, WebKitXPathResult * in_result, GError **error);

WEBKIT_API gboolean
webkit_document_exec_command (WebKitDocument *document, gchar * command, gboolean user_interface, gchar * value);

WEBKIT_API gboolean
webkit_document_query_command_enabled (WebKitDocument *document, gchar * command);

WEBKIT_API gboolean
webkit_document_query_command_indeterm (WebKitDocument *document, gchar * command);

WEBKIT_API gboolean
webkit_document_query_command_state (WebKitDocument *document, gchar * command);

WEBKIT_API gboolean
webkit_document_query_command_supported (WebKitDocument *document, gchar * command);

WEBKIT_API gchar *
webkit_document_query_command_value (WebKitDocument *document, gchar * command);

WEBKIT_API WebKitNodeList *
webkit_document_get_elements_by_name (WebKitDocument *document, gchar * element_name);

WEBKIT_API WebKitElement *
webkit_document_element_from_point (WebKitDocument *document, glong x, glong y);

WEBKIT_API WebKitCSSStyleDeclaration *
webkit_document_create_css_style_declaration (WebKitDocument *document);

WEBKIT_API WebKitNodeList *
webkit_document_get_elements_by_class_name (WebKitDocument *document, gchar * tagname);

WEBKIT_API WebKitElement *
webkit_document_query_selector (WebKitDocument *document, gchar * selectors, GError **error);

WEBKIT_API WebKitNodeList *
webkit_document_query_selector_all (WebKitDocument *document, gchar * selectors, GError **error);

WEBKIT_API WebKitDocumentType *
webkit_document_get_doctype (WebKitDocument *document);

WEBKIT_API WebKitDOMImplementation *
webkit_document_get_implementation (WebKitDocument *document);

WEBKIT_API WebKitElement *
webkit_document_get_document_element (WebKitDocument *document);

WEBKIT_API gchar *
webkit_document_get_input_encoding (WebKitDocument *document);

WEBKIT_API gchar *
webkit_document_get_xml_encoding (WebKitDocument *document);

WEBKIT_API gchar *
webkit_document_get_xml_version (WebKitDocument *document);

WEBKIT_API void
webkit_document_set_xml_version (WebKitDocument *document, gchar * value, GError **error);

WEBKIT_API gboolean
webkit_document_get_xml_standalone (WebKitDocument *document);

WEBKIT_API void
webkit_document_set_xml_standalone (WebKitDocument *document, gboolean value, GError **error);

WEBKIT_API gchar *
webkit_document_get_document_uri (WebKitDocument *document);

WEBKIT_API void
webkit_document_set_document_uri (WebKitDocument *document, gchar * value);

WEBKIT_API WebKitDOMWindow *
webkit_document_get_default_view (WebKitDocument *document);

WEBKIT_API WebKitStyleSheetList *
webkit_document_get_style_sheets (WebKitDocument *document);

WEBKIT_API gchar *
webkit_document_get_title (WebKitDocument *document);

WEBKIT_API void
webkit_document_set_title (WebKitDocument *document, gchar * value);

WEBKIT_API gchar *
webkit_document_get_referrer (WebKitDocument *document);

WEBKIT_API gchar *
webkit_document_get_domain (WebKitDocument *document);

WEBKIT_API gchar *
webkit_document_get_cookie (WebKitDocument *document);

WEBKIT_API void
webkit_document_set_cookie (WebKitDocument *document, gchar * value);

WEBKIT_API WebKitHTMLElement *
webkit_document_get_body (WebKitDocument *document);

WEBKIT_API void
webkit_document_set_body (WebKitDocument *document, WebKitHTMLElement * value, GError **error);

WEBKIT_API WebKitHTMLCollection *
webkit_document_get_images (WebKitDocument *document);

WEBKIT_API WebKitHTMLCollection *
webkit_document_get_applets (WebKitDocument *document);

WEBKIT_API WebKitHTMLCollection *
webkit_document_get_links (WebKitDocument *document);

WEBKIT_API WebKitHTMLCollection *
webkit_document_get_forms (WebKitDocument *document);

WEBKIT_API WebKitHTMLCollection *
webkit_document_get_anchors (WebKitDocument *document);

WEBKIT_API gchar *
webkit_document_get_last_modified (WebKitDocument *document);

WEBKIT_API gchar *
webkit_document_get_charset (WebKitDocument *document);

WEBKIT_API void
webkit_document_set_charset (WebKitDocument *document, gchar * value);

WEBKIT_API gchar *
webkit_document_get_default_charset (WebKitDocument *document);

WEBKIT_API gchar *
webkit_document_get_ready_state (WebKitDocument *document);

WEBKIT_API gchar *
webkit_document_get_character_set (WebKitDocument *document);

WEBKIT_API gchar *
webkit_document_get_preferred_stylesheet_set (WebKitDocument *document);

WEBKIT_API gchar *
webkit_document_get_selected_stylesheet_set (WebKitDocument *document);

WEBKIT_API void
webkit_document_set_selected_stylesheet_set (WebKitDocument *document, gchar * value);

G_END_DECLS

#endif /* __WebKitDocument_H__ */
