/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
 */
#ifndef __WebKitElement_H__
#define __WebKitElement_H__

#include "webkit/webkitdomdefines.h"
#include <glib-object.h>
#include <webkit/webkitdefines.h>
#include "webkit/WebKitNode.h"


G_BEGIN_DECLS


#define WEBKIT_TYPE_ELEMENT            (webkit_element_get_type())
#define WEBKIT_ELEMENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), WEBKIT_TYPE_ELEMENT, WebKitElement))
#define WEBKIT_ELEMENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  WEBKIT_TYPE_ELEMENT, WebKitElement)Class)
#define WEBKIT_IS_ELEMENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), WEBKIT_TYPE_ELEMENT))
#define WEBKIT_IS_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  WEBKIT_TYPE_ELEMENT))
#define WEBKIT_ELEMENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  WEBKIT_TYPE_ELEMENT, WebKitElementClass))

struct _WebKitElement {
    WebKitNode parent_instance;
};

struct _WebKitElementClass {
    WebKitNodeClass parent_class;
};

WEBKIT_API GType
webkit_element_get_type (void);

WEBKIT_API gchar *
webkit_element_get_attribute (WebKitElement *element, gchar * name);

WEBKIT_API void
webkit_element_set_attribute (WebKitElement *element, gchar * name, gchar * value, GError **error);

WEBKIT_API void
webkit_element_remove_attribute (WebKitElement *element, gchar * name, GError **error);

WEBKIT_API WebKitAttr *
webkit_element_get_attribute_node (WebKitElement *element, gchar * name);


/* TODO: custom function webkit_element_set_attribute_node */

WEBKIT_API WebKitAttr *
webkit_element_remove_attribute_node (WebKitElement *element, WebKitAttr * old_attr, GError **error);

WEBKIT_API WebKitNodeList *
webkit_element_get_elements_by_tag_name (WebKitElement *element, gchar * name);

WEBKIT_API gchar *
webkit_element_get_attribute_ns (WebKitElement *element, gchar * namespace_uri, gchar * local_name);


/* TODO: custom function webkit_element_set_attribute_ns */

WEBKIT_API void
webkit_element_remove_attribute_ns (WebKitElement *element, gchar * namespace_uri, gchar * local_name, GError **error);

WEBKIT_API WebKitNodeList *
webkit_element_get_elements_by_tag_name_ns (WebKitElement *element, gchar * namespace_uri, gchar * local_name);

WEBKIT_API WebKitAttr *
webkit_element_get_attribute_node_ns (WebKitElement *element, gchar * namespace_uri, gchar * local_name);


/* TODO: custom function webkit_element_set_attribute_node_ns */

WEBKIT_API gboolean
webkit_element_has_attribute (WebKitElement *element, gchar * name);

WEBKIT_API gboolean
webkit_element_has_attribute_ns (WebKitElement *element, gchar * namespace_uri, gchar * local_name);

WEBKIT_API void
webkit_element_focus (WebKitElement *element);

WEBKIT_API void
webkit_element_blur (WebKitElement *element);

WEBKIT_API void
webkit_element_scroll_into_view (WebKitElement *element, gboolean align_with_top);

WEBKIT_API gboolean
webkit_element_contains (WebKitElement *element, WebKitElement * element2);

WEBKIT_API void
webkit_element_scroll_into_view_if_needed (WebKitElement *element, gboolean center_if_needed);

WEBKIT_API void
webkit_element_scroll_by_lines (WebKitElement *element, glong lines);

WEBKIT_API void
webkit_element_scroll_by_pages (WebKitElement *element, glong pages);

WEBKIT_API WebKitNodeList *
webkit_element_get_elements_by_class_name (WebKitElement *element, gchar * name);

WEBKIT_API WebKitElement *
webkit_element_query_selector (WebKitElement *element, gchar * selectors, GError **error);

WEBKIT_API WebKitNodeList *
webkit_element_query_selector_all (WebKitElement *element, gchar * selectors, GError **error);

WEBKIT_API gchar *
webkit_element_get_tag_name (WebKitElement *element);

WEBKIT_API WebKitCSSStyleDeclaration *
webkit_element_get_style (WebKitElement *element);

WEBKIT_API glong
webkit_element_get_offset_left (WebKitElement *element);

WEBKIT_API glong
webkit_element_get_offset_top (WebKitElement *element);

WEBKIT_API glong
webkit_element_get_offset_width (WebKitElement *element);

WEBKIT_API glong
webkit_element_get_offset_height (WebKitElement *element);

WEBKIT_API WebKitElement *
webkit_element_get_offset_parent (WebKitElement *element);

WEBKIT_API glong
webkit_element_get_client_left (WebKitElement *element);

WEBKIT_API glong
webkit_element_get_client_top (WebKitElement *element);

WEBKIT_API glong
webkit_element_get_client_width (WebKitElement *element);

WEBKIT_API glong
webkit_element_get_client_height (WebKitElement *element);

WEBKIT_API glong
webkit_element_get_scroll_left (WebKitElement *element);

WEBKIT_API void
webkit_element_set_scroll_left (WebKitElement *element, glong value);

WEBKIT_API glong
webkit_element_get_scroll_top (WebKitElement *element);

WEBKIT_API void
webkit_element_set_scroll_top (WebKitElement *element, glong value);

WEBKIT_API glong
webkit_element_get_scroll_width (WebKitElement *element);

WEBKIT_API glong
webkit_element_get_scroll_height (WebKitElement *element);

WEBKIT_API WebKitElement *
webkit_element_get_first_element_child (WebKitElement *element);

WEBKIT_API WebKitElement *
webkit_element_get_last_element_child (WebKitElement *element);

WEBKIT_API WebKitElement *
webkit_element_get_previous_element_sibling (WebKitElement *element);

WEBKIT_API WebKitElement *
webkit_element_get_next_element_sibling (WebKitElement *element);

WEBKIT_API gulong
webkit_element_get_child_element_count (WebKitElement *element);

G_END_DECLS

#endif /* __WebKitElement_H__ */
