/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
 */
#ifndef __WebKitHTMLElement_H__
#define __WebKitHTMLElement_H__

#include "webkit/webkitdomdefines.h"
#include <glib-object.h>
#include <webkit/webkitdefines.h>
#include "webkit/WebKitElement.h"


G_BEGIN_DECLS


#define WEBKIT_TYPE_HTML_ELEMENT            (webkit_html_element_get_type())
#define WEBKIT_HTML_ELEMENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), WEBKIT_TYPE_HTML_ELEMENT, WebKitHTMLElement))
#define WEBKIT_HTML_ELEMENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  WEBKIT_TYPE_HTML_ELEMENT, WebKitHTMLElement)Class)
#define WEBKIT_IS_HTML_ELEMENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), WEBKIT_TYPE_HTML_ELEMENT))
#define WEBKIT_IS_HTML_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  WEBKIT_TYPE_HTML_ELEMENT))
#define WEBKIT_HTML_ELEMENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  WEBKIT_TYPE_HTML_ELEMENT, WebKitHTMLElementClass))

struct _WebKitHTMLElement {
    WebKitElement parent_instance;
};

struct _WebKitHTMLElementClass {
    WebKitElementClass parent_class;
};

WEBKIT_API GType
webkit_html_element_get_type (void);

WEBKIT_API void
webkit_html_element_blur (WebKitHTMLElement *element);

WEBKIT_API void
webkit_html_element_focus (WebKitHTMLElement *element);

WEBKIT_API WebKitElement *
webkit_html_element_insert_adjacent_element (WebKitHTMLElement *element, gchar * where, WebKitElement * element2, GError **error);

WEBKIT_API void
webkit_html_element_insert_adjacent_html (WebKitHTMLElement *element, gchar * where, gchar * html, GError **error);

WEBKIT_API void
webkit_html_element_insert_adjacent_text (WebKitHTMLElement *element, gchar * where, gchar * text, GError **error);

WEBKIT_API gchar *
webkit_html_element_get_id (WebKitHTMLElement *element);

WEBKIT_API void
webkit_html_element_set_id (WebKitHTMLElement *element, gchar * value);

WEBKIT_API gchar *
webkit_html_element_get_title (WebKitHTMLElement *element);

WEBKIT_API void
webkit_html_element_set_title (WebKitHTMLElement *element, gchar * value);

WEBKIT_API gchar *
webkit_html_element_get_lang (WebKitHTMLElement *element);

WEBKIT_API void
webkit_html_element_set_lang (WebKitHTMLElement *element, gchar * value);

WEBKIT_API gchar *
webkit_html_element_get_dir (WebKitHTMLElement *element);

WEBKIT_API void
webkit_html_element_set_dir (WebKitHTMLElement *element, gchar * value);

WEBKIT_API gchar *
webkit_html_element_get_class_name (WebKitHTMLElement *element);

WEBKIT_API void
webkit_html_element_set_class_name (WebKitHTMLElement *element, gchar * value);

WEBKIT_API glong
webkit_html_element_get_tab_index (WebKitHTMLElement *element);

WEBKIT_API void
webkit_html_element_set_tab_index (WebKitHTMLElement *element, glong value);

WEBKIT_API gchar *
webkit_html_element_get_inner_html (WebKitHTMLElement *element);

WEBKIT_API void
webkit_html_element_set_inner_html (WebKitHTMLElement *element, gchar * value, GError **error);

WEBKIT_API gchar *
webkit_html_element_get_inner_text (WebKitHTMLElement *element);

WEBKIT_API void
webkit_html_element_set_inner_text (WebKitHTMLElement *element, gchar * value, GError **error);

WEBKIT_API gchar *
webkit_html_element_get_outer_html (WebKitHTMLElement *element);

WEBKIT_API void
webkit_html_element_set_outer_html (WebKitHTMLElement *element, gchar * value, GError **error);

WEBKIT_API gchar *
webkit_html_element_get_outer_text (WebKitHTMLElement *element);

WEBKIT_API void
webkit_html_element_set_outer_text (WebKitHTMLElement *element, gchar * value, GError **error);

WEBKIT_API WebKitHTMLCollection *
webkit_html_element_get_children (WebKitHTMLElement *element);

WEBKIT_API gchar *
webkit_html_element_get_content_editable (WebKitHTMLElement *element);

WEBKIT_API void
webkit_html_element_set_content_editable (WebKitHTMLElement *element, gchar * value);

WEBKIT_API gboolean
webkit_html_element_get_is_content_editable (WebKitHTMLElement *element);

G_END_DECLS

#endif /* __WebKitHTMLElement_H__ */
