/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
 */
#ifndef __WebKitNode_H__
#define __WebKitNode_H__

#include "webkit/webkitdomdefines.h"
#include <glib-object.h>
#include <webkit/webkitdefines.h>
#include "webkit/WebKitDOMObject.h"


G_BEGIN_DECLS


#define WEBKIT_TYPE_NODE            (webkit_node_get_type())
#define WEBKIT_NODE(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), WEBKIT_TYPE_NODE, WebKitNode))
#define WEBKIT_NODE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  WEBKIT_TYPE_NODE, WebKitNode)Class)
#define WEBKIT_IS_NODE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), WEBKIT_TYPE_NODE))
#define WEBKIT_IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  WEBKIT_TYPE_NODE))
#define WEBKIT_NODE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  WEBKIT_TYPE_NODE, WebKitNodeClass))

struct _WebKitNode {
    WebKitDOMObject parent_instance;
};

struct _WebKitNodeClass {
    WebKitDOMObjectClass parent_class;
};

WEBKIT_API GType
webkit_node_get_type (void);

WEBKIT_API WebKitNode *
webkit_node_insert_before (WebKitNode *node, WebKitNode * new_child, WebKitNode * ref_child, GError **error);

WEBKIT_API WebKitNode *
webkit_node_replace_child (WebKitNode *node, WebKitNode * new_child, WebKitNode * old_child, GError **error);

WEBKIT_API WebKitNode *
webkit_node_remove_child (WebKitNode *node, WebKitNode * old_child, GError **error);

WEBKIT_API WebKitNode *
webkit_node_append_child (WebKitNode *node, WebKitNode * new_child, GError **error);

WEBKIT_API gboolean
webkit_node_has_child_nodes (WebKitNode *node);

WEBKIT_API WebKitNode *
webkit_node_clone_node (WebKitNode *node, gboolean deep);

WEBKIT_API void
webkit_node_normalize (WebKitNode *node);

WEBKIT_API gboolean
webkit_node_is_supported (WebKitNode *node, gchar * feature, gchar * version);

WEBKIT_API gboolean
webkit_node_has_attributes (WebKitNode *node);

WEBKIT_API gboolean
webkit_node_is_same_node (WebKitNode *node, WebKitNode * other);

WEBKIT_API gboolean
webkit_node_is_equal_node (WebKitNode *node, WebKitNode * other);

WEBKIT_API gchar *
webkit_node_lookup_prefix (WebKitNode *node, gchar * namespace_uri);

WEBKIT_API gboolean
webkit_node_is_default_namespace (WebKitNode *node, gchar * namespace_uri);

WEBKIT_API gchar *
webkit_node_lookup_namespace_uri (WebKitNode *node, gchar * prefix);

WEBKIT_API gushort
webkit_node_compare_document_position (WebKitNode *node, WebKitNode * other);


/* TODO: custom function webkit_node_add_event_listener */


/* TODO: custom function webkit_node_remove_event_listener */


/* TODO: event function webkit_node_dispatch_event */

WEBKIT_API gchar *
webkit_node_get_node_name (WebKitNode *node);

WEBKIT_API gchar *
webkit_node_get_node_value (WebKitNode *node);

WEBKIT_API void
webkit_node_set_node_value (WebKitNode *node, gchar * value, GError **error);

WEBKIT_API gushort
webkit_node_get_node_type (WebKitNode *node);

WEBKIT_API WebKitNode *
webkit_node_get_parent_node (WebKitNode *node);

WEBKIT_API WebKitNodeList *
webkit_node_get_child_nodes (WebKitNode *node);

WEBKIT_API WebKitNode *
webkit_node_get_first_child (WebKitNode *node);

WEBKIT_API WebKitNode *
webkit_node_get_last_child (WebKitNode *node);

WEBKIT_API WebKitNode *
webkit_node_get_previous_sibling (WebKitNode *node);

WEBKIT_API WebKitNode *
webkit_node_get_next_sibling (WebKitNode *node);

WEBKIT_API WebKitNamedNodeMap *
webkit_node_get_attributes (WebKitNode *node);

WEBKIT_API WebKitDocument *
webkit_node_get_owner_document (WebKitNode *node);

WEBKIT_API gchar *
webkit_node_get_namespace_uri (WebKitNode *node);

WEBKIT_API gchar *
webkit_node_get_prefix (WebKitNode *node);

WEBKIT_API void
webkit_node_set_prefix (WebKitNode *node, gchar * value, GError **error);

WEBKIT_API gchar *
webkit_node_get_local_name (WebKitNode *node);

WEBKIT_API gchar *
webkit_node_get_base_uri (WebKitNode *node);

WEBKIT_API gchar *
webkit_node_get_text_content (WebKitNode *node);

WEBKIT_API void
webkit_node_set_text_content (WebKitNode *node, gchar * value, GError **error);

WEBKIT_API WebKitNode *
webkit_node_get_parent_element (WebKitNode *node);

G_END_DECLS

#endif /* __WebKitNode_H__ */
