/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
 */
#ifndef __WebKitRange_H__
#define __WebKitRange_H__

#include "webkit/webkitdomdefines.h"
#include <glib-object.h>
#include <webkit/webkitdefines.h>
#include "webkit/WebKitDOMObject.h"


G_BEGIN_DECLS


#define WEBKIT_TYPE_RANGE            (webkit_range_get_type())
#define WEBKIT_RANGE(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), WEBKIT_TYPE_RANGE, WebKitRange))
#define WEBKIT_RANGE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  WEBKIT_TYPE_RANGE, WebKitRange)Class)
#define WEBKIT_IS_RANGE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), WEBKIT_TYPE_RANGE))
#define WEBKIT_IS_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  WEBKIT_TYPE_RANGE))
#define WEBKIT_RANGE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  WEBKIT_TYPE_RANGE, WebKitRangeClass))

struct _WebKitRange {
    WebKitDOMObject parent_instance;
};

struct _WebKitRangeClass {
    WebKitDOMObjectClass parent_class;
};

WEBKIT_API GType
webkit_range_get_type (void);

WEBKIT_API void
webkit_range_set_start (WebKitRange *range, WebKitNode * ref_node, glong offset, GError **error);

WEBKIT_API void
webkit_range_set_end (WebKitRange *range, WebKitNode * ref_node, glong offset, GError **error);

WEBKIT_API void
webkit_range_set_start_before (WebKitRange *range, WebKitNode * ref_node, GError **error);

WEBKIT_API void
webkit_range_set_start_after (WebKitRange *range, WebKitNode * ref_node, GError **error);

WEBKIT_API void
webkit_range_set_end_before (WebKitRange *range, WebKitNode * ref_node, GError **error);

WEBKIT_API void
webkit_range_set_end_after (WebKitRange *range, WebKitNode * ref_node, GError **error);

WEBKIT_API void
webkit_range_collapse (WebKitRange *range, gboolean to_start, GError **error);

WEBKIT_API void
webkit_range_select_node (WebKitRange *range, WebKitNode * ref_node, GError **error);

WEBKIT_API void
webkit_range_select_node_contents (WebKitRange *range, WebKitNode * ref_node, GError **error);


/* TODO: skipping CompareHow function webkit_range_compare_boundary_points */

WEBKIT_API void
webkit_range_delete_contents (WebKitRange *range, GError **error);

WEBKIT_API WebKitDocumentFragment *
webkit_range_extract_contents (WebKitRange *range, GError **error);

WEBKIT_API WebKitDocumentFragment *
webkit_range_clone_contents (WebKitRange *range, GError **error);

WEBKIT_API void
webkit_range_insert_node (WebKitRange *range, WebKitNode * new_node, GError **error);

WEBKIT_API void
webkit_range_surround_contents (WebKitRange *range, WebKitNode * new_parent, GError **error);

WEBKIT_API WebKitRange *
webkit_range_clone_range (WebKitRange *range, GError **error);

WEBKIT_API gchar *
webkit_range_to_string (WebKitRange *range, GError **error);

WEBKIT_API void
webkit_range_detach (WebKitRange *range, GError **error);

WEBKIT_API WebKitDocumentFragment *
webkit_range_create_contextual_fragment (WebKitRange *range, gchar * html, GError **error);

WEBKIT_API gboolean
webkit_range_intersects_node (WebKitRange *range, WebKitNode * ref_node, GError **error);

WEBKIT_API gshort
webkit_range_compare_node (WebKitRange *range, WebKitNode * ref_node, GError **error);

WEBKIT_API gshort
webkit_range_compare_point (WebKitRange *range, WebKitNode * ref_node, glong offset, GError **error);

WEBKIT_API gboolean
webkit_range_is_point_in_range (WebKitRange *range, WebKitNode * ref_node, glong offset, GError **error);

WEBKIT_API WebKitNode *
webkit_range_get_start_container (WebKitRange *range, GError **error);

WEBKIT_API glong
webkit_range_get_start_offset (WebKitRange *range, GError **error);

WEBKIT_API WebKitNode *
webkit_range_get_end_container (WebKitRange *range, GError **error);

WEBKIT_API glong
webkit_range_get_end_offset (WebKitRange *range, GError **error);

WEBKIT_API gboolean
webkit_range_get_collapsed (WebKitRange *range, GError **error);

WEBKIT_API WebKitNode *
webkit_range_get_common_ancestor_container (WebKitRange *range, GError **error);

WEBKIT_API gchar *
webkit_range_get_text (WebKitRange *range);

G_END_DECLS

#endif /* __WebKitRange_H__ */
